config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users, controllers: {
    registrations: 'users/registrations'
  }

  resource  :user_profiles, only: %i[edit update]
  resources :tweets

  root to: 'home#index'
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/tweet.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: tweets
#
#  id         :integer          not null, primary key
#  content    :string
#  user_id    :integer
#  created_at :datetime         not null
#  updated_at :datetime         not null
#

class Tweet < ApplicationRecord
  MAX_CONTENT_LENGTH = 240

  belongs_to :user

  validates :content, presence: true, length: { maximum: MAX_CONTENT_LENGTH }
end

app/models/user.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: users
#
#  id                     :integer          not null, primary key
#  email                  :string           default(""), not null
#  encrypted_password     :string           default(""), not null
#  reset_password_token   :string
#  reset_password_sent_at :datetime
#  remember_created_at    :datetime
#  created_at             :datetime         not null
#  updated_at             :datetime         not null
#

class User < ApplicationRecord
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_one  :user_profile, dependent: :destroy, inverse_of: :user
  has_many :tweets,       dependent: :destroy

  accepts_nested_attributes_for :user_profile,
                                reject_if:     :all_blank,
                                allow_destroy: true
end

app/models/user_profile.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: user_profiles
#
#  id         :integer          not null, primary key
#  username   :string
#  first_name :string
#  last_name  :string
#  birthday   :date
#  bio        :string
#  user_id    :integer
#  created_at :datetime         not null
#  updated_at :datetime         not null
#

class UserProfile < ApplicationRecord
  belongs_to :user, inverse_of: :user_profile

  validates :birthday,
            :bio,
            :first_name,
            :last_name,
            :username, presence: true
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  before_action :authenticate_user!

  respond_to :html
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index
    @user_profile = current_user.user_profile
    @tweets       = Tweet.all.reverse
    @users        = User.all.except(current_user)
  end
end

app/controllers/tweets_controller.rb
# frozen_string_literal: true

class TweetsController < ApplicationController
  def index
    @tweets = current_user.tweets.reverse
    @users  = User.all.except(current_user)
  end

  def create
    @tweet = Tweet.new(tweet_params)

    if @tweet.save
      redirect_to root_path,
                  flash: { notice: 'Tweet was successfully created.' }
    else
      redirect_to root_path,
                  flash: { error: @tweet.errors.full_messages.to_sentence }
    end
  end

  private

  def tweet_params
    params.require(:tweet).permit(:content, :user_id)
  end
end

app/controllers/user_profiles_controller.rb
# frozen_string_literal: true

class UserProfilesController < ApplicationController
  before_action :set_user_profile

  def edit; end

  def update
    if @user_profile.update(user_profile_params)
      redirect_to user_profiles_path,
                  notice: 'Your profile was successfully updated.'
    else
      render :edit
    end
  end

  private

  def set_user_profile
    @user_profile = current_user&.user_profile
  end

  def user_profile_params
    params.require(:user_profile)
      .permit(:username, :first_name, :last_name, :birthday, :bio, :user_id)
  end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

module Users
  class RegistrationsController < Devise::RegistrationsController
    before_action :configure_sign_up_params, only: :create

    def new
      build_resource({})
      resource.build_user_profile
      respond_with resource
    end

    def configure_sign_up_params
      devise_parameter_sanitizer.permit(:sign_up, keys: sign_up_params_keys)
    end

    def sign_up_params_keys
      [user_profile_attributes: %i[username first_name last_name birthday bio]]
    end
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  def bootstrap_class_for_flash(flash_type)
    case flash_type
    when 'success'
      'alert-success'
    when 'error'
      'alert-danger'
    when 'alert'
      'alert-warning'
    when 'notice'
      'alert-info'
    end
  end
end

app/views/home/_profile_info.html.erb
<div class="card">
  <div class="card-body">
    <h3 class="card-title">
      <%= profile.username %>
    </h3>
    <h6 class="card-subtitle mb-2 text-muted">
      <%= profile.first_name %>
      <%= profile.last_name %>
    </h6>
    <hr>

    <p class="card-text">
          <span>
            <strong>Date of birth:</strong>
          </span>
      <span>
            <%= profile.birthday&.strftime('%D') %>
          </span>
    </p>
    <p class="card-text">
      <strong>Bio:</strong>
      <%= profile.bio %>
    </p>
    <hr>
    <p class="card-text my-tweets-section">
      <strong>
        <%= link_to 'My Tweets', tweets_path, class: 'card-link' %>:
      </strong>
      <%= profile.user.tweets.count %>
    </p>
    <hr>

    <%= link_to 'Edit', edit_user_profiles_path, class: 'card-link' %>
  </div>
</div>

app/views/home/_profile_preview.html.erb
<h6>
  <strong>
    <%= user.user_profile.first_name %>
    <%= user.user_profile.last_name %>
  </strong>
  @<%= user.user_profile.username %>
</h6>
<hr>

app/views/home/_users_list.html.erb
<h4>Who is here?</h4>
<hr>
<%= render partial: 'home/profile_preview', collection: users, as: :user %>

app/views/home/index.html.erb
<div class="row">
  <div class="col-md-3">
    <%= render 'home/profile_info', profile: current_user.user_profile %>
  </div>

  <div class="col-md-6">
    <%= render 'tweets/form' %>

    <hr>

    <%= render partial: 'tweets/tweet_preview', collection: @tweets, as: :tweet %>
  </div>


  <div class="col-md-3">
    <%= render 'home/users_list', users: @users %>
  </div>
</div>

app/views/layouts/_flash.html.erb
<div class="container">
  <% flash.each do |type, msg| %>
    <div class="alert <%= bootstrap_class_for_flash(type) %> alert-dismissable">
      <%= msg %>
      <button class="close" data-dismiss="alert">x</button>
    </div>
  <% end %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Homework6</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
    
    <meta name="viewport" content="width=device-width, initial-scale=1">
  </head>

  <body>
    <nav class="navbar sticky-top navbar-expand-lg navbar-dark bg-primary">
      <a class="navbar-brand" href="#">Twitter</a>

      <div class="collapse navbar-collapse d-flex justify-content-center">
        <div class="navbar-nav">
          <a class="nav-item nav-link active" href="/">Home</a>

          <% if current_user %>
            <%= link_to "Log Out", destroy_user_session_path, method: :delete, class: 'nav-item nav-link' %>
          <% end %>
        </div>
      </div>
    </nav>

    <div class="container mt-2">
      <%= render partial: 'layouts/flash', flash: flash %>
    </div>

    <div class="container mt-5">
      <%= yield %>
    </div>
  </body>
</html>

app/views/tweets/_form.html.erb
<h4>What's happening?</h4>
<%= form_with(model: current_user.tweets.build, url: tweets_path) do |form| %>
  <%= form.hidden_field :user_id, value: current_user.id %>
  <%= form.text_area :content, class: 'form-control', rows: 3 %>

  <div class="d-flex justify-content-end mt-2">
    <%= form.button :tweet, type: :submit, class: 'btn btn-info' %>
  </div>
<% end %>

app/views/tweets/_tweet_preview.html.erb
<div class="card mb-3" id="tweet-<%= tweet.id %>">
  <div class="card-body">
    <h5 class="card-title">
      <strong>
        <%= tweet.user.user_profile.first_name %>
        <%= tweet.user.user_profile.last_name %>
      </strong>
      @<%= tweet.user.user_profile.username %>
      <small>
        | <%= tweet.created_at&.strftime('%D')  %>
      </small>
    </h5>

    <p class="card-text">
      <%= tweet.content %>
    </p>
  </div>
</div>

app/views/tweets/index.html.erb
<div class="row">
  <div class="col-md-3">
    <%= render 'home/profile_info', profile: current_user.user_profile %>
  </div>

  <div class="col-md-6">
    <h4>
      <strong>
        Tweets count: <%= @tweets.count %>
      </strong>
    </h4>

    <hr>

    <%= render partial: 'tweets/tweet_preview', collection: @tweets, as: :tweet %>
  </div>


  <div class="col-md-3">
    <%= render 'home/users_list', users: @users %>
  </div>
</div>

app/views/user_profiles/_form.html.erb
<%= form_with(model: user_profile, url: user_profiles_path, html: { class: 'devise-form' }) do |form| %>
  <% if user_profile.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user_profile.errors.count, "error") %> prohibited this user_profile from being saved:</h2>

      <ul>
      <% user_profile.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <%= form.text_field :first_name, class: 'form-control first-field', placeholder: true %>
  <%= form.text_field :last_name,  class: 'form-control inner-field', placeholder: true %>
  <%= form.date_field :birthday,   class: 'form-control inner-field', placeholder: true %>
  <%= form.text_field :username,   class: 'form-control inner-field', placeholder: true %>
  <%= form.text_field :bio,        class: 'form-control last-field',  placeholder: true %>
  <%= form.button :Submit,         class: 'btn btn-primary btn-block' %>
<% end %>

app/views/user_profiles/edit.html.erb
<div class="text-center">
  <h1 class="h3 mb-3 font-weight-normal"> Edit profile </h1>

  <%= render 'form', user_profile: @user_profile %>
</div>